# class Crystal::Macros::Primitive

- Crystal::Macros::Primitive
- Crystal::Macros::ASTNode

##
Overview

A fictitious node representing the body of a `Def` marked with `@[Primitive]`.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #name : SymbolLiteral

  Returns the name of the primitive.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def name : SymbolLiteral #

Returns the name of the primitive.

This is identical to the argument to the associated `@[Primitive]` annotation.

    module Foo
      @[Primitive(:abc)]
      def foo
      end
    end

    {{ Foo.methods.first.body.name }} # => :abc